/// <reference types="node" />
import { IPluginStorage, Logger, PluginOptions, Callback, IPackageStorage, Token, TokenFilter } from '@verdaccio/types';
import { PGConfig } from './config';
export declare class PGDatabase implements IPluginStorage<PGConfig> {
    logger: Logger;
    config: PGConfig;
    locked: boolean;
    private database;
    private token;
    private localPackage;
    private verdaccioSecret;
    constructor(config: PGConfig, options: PluginOptions<PGConfig>);
    getSecret: () => Promise<string>;
    setSecret: (secret: string) => Promise<void>;
    add: (arg1: string, callback: (err: NodeJS.ErrnoException) => void) => void;
    search: (onPackage: Callback, onEnd: Callback) => void;
    remove: (arg1: string, callback: (err: NodeJS.ErrnoException) => void) => void;
    get: (callback: (err: NodeJS.ErrnoException, result: string[]) => void) => void;
    getPackageStorage: (name: string) => IPackageStorage;
    clean: (callback: (err: NodeJS.ErrnoException) => void) => void;
    saveToken: (token: Token) => Promise<void>;
    deleteToken: (user: string, token: string) => Promise<void>;
    readTokens: (filter: TokenFilter) => Promise<Token[]>;
}
