import { Token as VerdaccioToken, TokenFilter, Logger } from '@verdaccio/types';
import { Database } from '../database';
export interface Token {
    user: string;
    token: string;
    key: string;
    cidr?: string[];
    readonly: boolean;
    created: Date;
    updated?: Date;
}
export declare class TokenService {
    private database;
    private logger;
    constructor(database: Database, logger: Logger);
    save: (token: VerdaccioToken) => Promise<void>;
    deleteToken: (user: string, key: string) => Promise<void>;
    readToken: ({ user }: TokenFilter) => Promise<VerdaccioToken[]>;
    static toVerdaccioToken: (token: Token) => VerdaccioToken;
    static fromVerdaccioToken: (token: VerdaccioToken) => Token;
}
