"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TokenService = void 0;

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/* eslint-disable no-invalid-this */
class TokenService {
  constructor(database, logger) {
    _defineProperty(this, "database", void 0);

    _defineProperty(this, "logger", void 0);

    _defineProperty(this, "save", async token => {
      this.logger.debug({
        uesr: token.user,
        key: token.key
      }, '[pg-storage/token]: save token for user @{user} and key @{key}');
      const sql = await this.database.sql();
      await sql`
      INSERT INTO tokens ${sql(TokenService.fromVerdaccioToken(token))}
    `;
      this.logger.debug({
        uesr: token.user,
        key: token.key
      }, '[pg-storage/token]: token for user @{user} and key @{key} saved');
    });

    _defineProperty(this, "deleteToken", async (user, key) => {
      this.logger.debug({
        user,
        key
      }, '[pg-storage/token]: delete token for user @{user} and key @{key}');
      const sql = await this.database.sql();
      await sql`
      DELETE FROM tokens WHERE user = ${user} AND key = ${key}
    `;
      this.logger.debug({
        user,
        key
      }, '[pg-storage/token]: token for user @{user} and key @{key} deleted');
    });

    _defineProperty(this, "readToken", async ({
      user
    }) => {
      this.logger.debug({
        user
      }, '[pg-storage/token]: read all token for user @{user}');
      const sql = await this.database.sql();
      const rows = await sql`SELECT * FROM tokens WHERE user = ${user}`;
      this.logger.debug({
        user
      }, '[pg-storage/token]: all token for user @{user} read');
      return rows.map(TokenService.toVerdaccioToken);
    });

    this.database = database;
    this.logger = logger;
  }

}

exports.TokenService = TokenService;

_defineProperty(TokenService, "toVerdaccioToken", token => {
  return _objectSpread({}, token, {
    created: token.created.getTime(),
    updated: token.updated && token.updated.getTime()
  });
});

_defineProperty(TokenService, "fromVerdaccioToken", token => {
  return _objectSpread({}, token, {
    created: new Date(token.created),
    updated: token.updated && new Date(token.updated) || undefined
  });
});