"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.VerdaccioSecretService = void 0;

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/* eslint-disable no-invalid-this */
class VerdaccioSecretService {
  constructor(database, logger) {
    _defineProperty(this, "database", void 0);

    _defineProperty(this, "logger", void 0);

    _defineProperty(this, "set", async secret => {
      this.logger.debug('[pg-storage/verdaccio-secret]: save secret');
      const sql = await this.database.sql();
      await sql`
      INSERT INTO secrets
        (name, value, created, updated)
      VALUES
        ('verdaccio', ${secret}, NOW(), NOW())
        ON CONFLICT (name) DO UPDATE SET updated = NOW(), value = ${secret}
    `;
      this.logger.debug('[pg-storage/verdaccio-secret]: secret saved');
    });

    _defineProperty(this, "get", async () => {
      this.logger.debug('[pg-storage/verdaccio-secret]: get secret');
      const sql = await this.database.sql();
      const [secret] = await sql`SELECT value FROM secrets WHERE name = 'verdaccio'`;
      this.logger.debug('[pg-storage/verdaccio-secret]: secret saved');
      return secret ? secret.value : '';
    });

    this.database = database;
    this.logger = logger;
  }

}

exports.VerdaccioSecretService = VerdaccioSecretService;